;--------------------------------------------------------------------------------------------
;Le programme lit en boucle  intervalles de temps rguliers l'entre analogique 
;et envoie les 8bits de poids forts du rsultat de la conversion  sur le port D
;Le Timer 3 est utilis pour fixer l'intervalle de temps entre 2 conversions
;Le programme scrute en permanence le timer 3  (on n'utilise pas les interruptions )
;--------------------------------------------------------------------------------------------
		.global			__reset	;  adresse 000000 de la mmoire programme  ( voir fichier 30F6014.gld  ) 
		.section        .text	;  indique au  linker d'utiliser la mmoire programme

__reset:rcall   _init_timer3    ;  appel de sous-programmes                  
		rcall   _init_adc
		rcall   _init_portD
boucle1:clr TMR3
boucle2:mov TMR3,W0
		mov #0x2E5,W1
		sub W0,W1,W0
		bra LT,boucle2			; on attend 0X300
		mov ADCBUF0,W0			;lecture AN0 
		lsr W0,#8,W0			;dcalage  droite de huit bits 
		mov W0,PORTD			;envoi en sortie	
		bra boucle1
;fin du_programme principal

;*******************************************
;    Les sous-programmes
;*******************************************   
_init_portD:
		clr TRISD
		return
_init_timer3:
		mov #0x8000,W0
		mov W0,T3CON
		mov #0xFFFF,W0
		mov W0,PR3
		return
_init_adc:
		clr ADPCFG
		mov #0x0400,W0
		mov W0,ADCON2
		mov #0x010A,W0
		mov W0,ADCON3
		mov #0x0000,W0
		mov W0,ADCHS
		mov #0x0001,W0
		mov W0,ADCSSL
		mov #0x82E6,W0
		mov W0,ADCON1
		return

.end   						; fin du fichier




